#include <GL/glut.h>
#include <cstdlib>
#include <cstdio>
#include <time.h>
#include <math.h>
#include <iostream>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/times.h>
#include <gtk/gtk.h>
extern void bezier_init(void);
extern void etoileLoop();
#ifndef CLK_TCK
const int CLK_TCK = sysconf(_SC_CLK_TCK);
/* timedelta: returns the number of seconds that have elapsed since
   the previous call to the function. */
#endif
float
timedelta(void)
{
    static long begin = 0;
    static long finish, difference;
    static struct tms tb;

    std::cout <<CLK_TCK <<std::endl;
   finish = times(&tb);

    difference = finish - begin;
    begin = finish;

	/* CLK_TCK=100 */
    return (float)difference/(float)CLK_TCK;
}
extern
void draw_gl(void);

void
display(void)
{
    draw_gl();
    glutSwapBuffers();

}

extern void bezier_render_freq(gint16 spectrum[2][256]);
gint16 spectrum[2][256];
float mytime=0;
void
idleFunc(void)
{
    mytime+=0.8;
    for(int i=0;i<256;i++)
    {
        spectrum[0][i]=(int) (10.*(exp(cos(mytime))));
        
        spectrum[1][i]=(int)(10.*(exp(sin(mytime))));
    }
    //cout<< spectrum[0][0]<<endl;
    bezier_render_freq(spectrum);
    etoileLoop();
  glutPostRedisplay();

}
void
visible(int state)
{
    printf("visible\n");

    if (state == GLUT_VISIBLE) {
        timedelta();
	glutIdleFunc(idleFunc);
    } else {
	glutIdleFunc(0);
    }
}

void
bail(int code)
{
    exit(code);
}

void
reshape(int width, int height)
{
    printf("reshape\n");

/*    glViewport(0, 0, width, height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(60, 1, 0.1, 1000);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    gluLookAt(0, 1, 3, 0, 1, 0, 0, 1, 0);
    glFogfv(GL_FOG_COLOR, black);
    glFogf(GL_FOG_START, 2.5);
    glFogf(GL_FOG_END, 4);
    glEnable(GL_FOG);
    glFogi(GL_FOG_MODE, GL_LINEAR);
    glPointSize(point_size);
    glEnable(GL_POINT_SMOOTH);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_COLOR_MATERIAL);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHT0);
*/
}
void init_gl(void);
float spin_x = 0;
float spin_y = 0;
float old_x = 0;
float old_y = 0;

/* ARGSUSED */
void
mouse(int button, int state, int x, int y)
{
    old_x = x;
    old_y = y;

    glutPostRedisplay();
}

void
motion(int x, int y)
{
    spin_x = x - old_x;
    spin_y = y - old_y;

    glutPostRedisplay();
}
void
keyboard(unsigned char key, int x, int y)
{
    switch (key) {
    case 27:
        bail(0);
	break;
    }
}
int main(int argc , char **argv)
{
  glutInitDisplayMode(GLUT_RGB|GLUT_DEPTH|GLUT_DOUBLE);
  glutInitWindowPosition(50, 50);
  glutInitWindowSize(640, 480);
  glutInit(&argc, argv);
  if (argc > 1 && !strcmp(argv[1], "-fullscreen")) {
    glutGameModeString("800x600:24@20");
    glutEnterGameMode();
  } else {
    glutCreateWindow("Particles");
  }
  srand(time(NULL));
  init_gl();
  glutDisplayFunc(display);
  glutReshapeFunc(reshape);
#if 1
  glutMotionFunc(motion);
  glutMouseFunc(mouse);
  glutKeyboardFunc(keyboard);
#endif


  glutVisibilityFunc(visible);
  glutMainLoop();

  return 0;
}
